// Defines constants with the limits of fundamental integral types for the specific system and compiler implementation used.

//TODO: Convert all limits to macros

// Number of bits in a char object
const char CHAR_BIT = 8;
// Minimum value of char type
const char CHAR_MIN = 0;
// Maximum value of char type
const char CHAR_MAX = 255;
// Minimum value of signed char type
const signed char SCHAR_MIN = -128;
// Maximum value of signed char type
const signed char SCHAR_MAX = 127;
// Maximum value of unsigned char type
const unsigned char UCHAR_MAX = 255;
// Minimum value of unsigned short type
const unsigned short USHRT_MAX = 65535;
// Minimum value signed short type
const short SHRT_MIN = -32768;
// Maximum value of signed short type
const short SHRT_MAX = 32767;
// Minimum value of unsigned int type
const unsigned int UINT_MAX = 65535;
// Minimum value signed int type
const int INT_MIN = -32768;
// Maximum value of signed int type
const int INT_MAX = 32767;
// Maximum value of unsigned long type
const unsigned long ULONG_MAX = 4194304;
// Minimum value of signed long type
const long LONG_MIN = -2097152;
// Maximum value of signed long type
const long LONG_MAX = 2097151;
